#include <stdio.h>
#include "par_child.h"

void get_parent_and_children( int i, int r, int s,
                              int *parent, int *left_ch, int *right_ch )
{
    // Shift as if root were 0
    int dummy_i = ((i+s) - r) % s;

    // Compute parent and children according to the shift
    *left_ch  = dummy_i * 2 + 1;
    *right_ch = dummy_i * 2 + 2;
    *parent = (dummy_i-1)/2;

    if (*left_ch >= s)
        *left_ch = -1;
    if (*right_ch >= s)
        *right_ch = -1;
    if (dummy_i == 0)
        *parent = -1;

    // Adjust back
    if (*parent != -1)
        *parent = (*parent + r) % s;
    if (*left_ch != -1)
        *left_ch = (*left_ch + r) % s;
    if (*right_ch != -1)
        *right_ch = (*right_ch + r) % s;
}
